<!-- pagina per la gestione di errori -->
<%@ page errorPage="../errors/failure.jsp"%>

<!-- accesso alla sessione -->
<%@ page session="true"%>

<!-- import di classi Java -->
<%@ page import="it.unibo.tw.dao.ItemDTO"%>
<%@page import="it.unibo.tw.dao.DAOFactory"%>
<%@page import="it.unibo.tw.dao.ItemDAO"%>
<%@page import="java.util.List"%>

<!-- librerie di terze parti -->
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %> 

<!-- metodi richiamati nel seguito -->
<%!
ItemDAO getItemDAO(String type) {
	return DAOFactory
		.getDAOFactory(
			Integer.parseInt(
				// can't use builtin object 'application' while in a declaration! 
				// must be in a scriptlet or expression!
				//application.getInitParameter("daoFactory")
					type)
			).getItemDAO();
}

%>

<!-- codice html restituito al client -->

<html>
	<head>
		<meta name="Author" content="pisi79">
		<title>Catalogue JSP</title>
		<link rel="stylesheet" href="<%=request.getContextPath()%>/styles/default.css" type="text/css"/>
	</head>

	<body>	

		<%@ include file="../fragments/header.jsp" %>
		<%@ include file="../fragments/menu.jsp" %>
	
		<div id="main" class="clear">

			<%
				
				if ( request.getParameter("add") != null && ! request.getParameter("add").equals("") ) {
					ItemDTO item = new ItemDTO();
					item.setName(request.getParameter("name"));
					item.setDescription( request.getParameter("description") );
					item.setPrice( Double.parseDouble( request.getParameter("price") ) );
					item.setAvailability( Integer.parseInt(request.getParameter("availability") ) );
					getItemDAO(application.getInitParameter("dao")).create(item);
				}
				else if ( request.getParameter("update") != null && ! request.getParameter("update").equals("") ) {
					ItemDTO item = new ItemDTO();
					item.setId(Long.parseLong(request.getParameter("id")));
					item.setName(request.getParameter("name"));
					item.setDescription( request.getParameter("description") );
					item.setPrice( Double.parseDouble( request.getParameter("price") ) );
					item.setAvailability( Integer.parseInt(request.getParameter("availability") ) );
					getItemDAO(application.getInitParameter("dao")).update(item);
				}
				else if ( request.getParameter("remove") != null && ! request.getParameter("remove").equals("") ) {
					getItemDAO(application.getInitParameter("dao")).delete(Long.parseLong(request.getParameter("id")));
				}
						
			%>
			
			<div id="left" style="float: left; width: 48%; border-right: 1px solid grey">
			
				<p>Add an item to the catalogue:</p>
				<form>
					<table>
						<tr><td>
							<label for="desc">Name:</label>
						</td><td>
							<input type="text" name="name"/>
						</td></tr>
						<tr><td>
							<label for="desc">Description:</label>
						</td><td>
							<input type="text" name="description"/>
						</td></tr>
						<tr><td>
							<label for="price">Price (&#8364;):</label>
						</td><td>
							<input type="text" name="price"/>
						</td></tr>
						<tr><td>
							<label for="price">Availability:</label>
						</td><td>
							<input type="text" name="availability"/>
						</td></tr>
						<tr><td colspan="2">
							<input type="submit" name="add" value="submit item" style="width:100%"/>
						</td></tr>
					</table>
				</form>
		
			</div>
			
			<div id="right" style="float: right; width: 48%">

				<p>Current catalogue:</p>
				<table class="formdata">
					<tr>
						<th style="width: 20%">Name</th>
						<th style="width: 20%">Description</th>
						<th style="width: 10%">Price</th>
						<th style="width: 15%">Availability</th>
						<th style="width: 10%"></th>
						<th style="width: 5%"></th>
					</tr>
					<% 
					List<ItemDTO> items = getItemDAO( application.getInitParameter("dao") ).find(null);
					for ( ItemDTO item : items ) {
					%><form>
						<tr>
							<input type="hidden" name="edit" value="ok"/>
							<input type="hidden" name="id" value="<%= item.getId() %>"/>
							<td><input type="text" name="name" value="<%= item.getName()%>"/></td>
							<td><input type="text" name="description" value="<%= item.getDescription()%>"/></td>
							<td><input type="text" name="price" value="<%= item.getPrice()%>"/></td>
							<td><input type="text" name="availability" value="<%= item.getAvailability() %>"/></td>
							<td><input type="submit" name="update" value="update"/></td>
							<td><a href="?remove=ok&id=<%=item.getId() %>"><img src="../images/remove.gif" alt="remove"/></a></td>
						</tr>
						</form>
					<%
					}
					%>
					<% 
					if ( items == null || items.size() == 0 ) {
					%>
					<tr>
						<td>&nbsp;</td>
						<td>&nbsp;</td>
						<td>&nbsp;</td>
						<td>&nbsp;</td>
					</tr>
					<%
					}
					%>
				</table>			
			</div>
		
			<div class="clear">
				<p>&nbsp;</p>
			</div>
			
		</div>
	
		<%@ include file="../fragments/footer.jsp" %>

	</body>
</html>
