package it.unibo.tw.web.servlets;

import it.unibo.tw.dao.DAOFactory;
import it.unibo.tw.dao.ItemDTO;
import it.unibo.tw.dao.OrderDAO;
import it.unibo.tw.dao.OrderDTO;
import it.unibo.tw.dao.OrderItemDTO;
import it.unibo.tw.web.beans.Cart;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

public class CheckoutServlet extends HttpServlet {

	private static final long serialVersionUID = 1L;

	private OrderDAO getOrderDAO(HttpServletRequest req) {
		return DAOFactory
		.getDAOFactory(
			Integer.parseInt(
				super.getServletContext().getInitParameter("dao")
			)
		).getOrderDAO();
	}

	@Override
	public void doPost(HttpServletRequest req, HttpServletResponse resp)
	throws ServletException, IOException {
		
		String buyer = req.getParameter("buyer");
		String address = req.getParameter("address");
		String email = req.getParameter("email");
		

		if ( buyer == null || buyer.length() == 0 || address == null || address.length() == 0 || email == null || email.length() == 0 ) {
			// oppure
			resp.sendRedirect(req.getContextPath()+"/pages/checkout.jsp?buyer="+buyer+"&address="+address+"&email="+email);
			return;
			// un altro forward eseguito lato servlet
//			req.getRequestDispatcher("/pages/checkout.jsp").forward(req, resp);
		}
		
		else {
	
			Cart cart = (Cart) req.getSession().getAttribute("cart");
	
			OrderDTO order = new OrderDTO();
			order.setBuyer(buyer);
			order.setShipment(address);
			order.setEmail(email);
			List<OrderItemDTO> order_items = new ArrayList<OrderItemDTO>();
			for ( ItemDTO item : cart.getItems() ) {
				OrderItemDTO order_item = new OrderItemDTO();
				order_item.setItemDTO(item);
				order_item.setQuantity( cart.get(item) );
			}
			order.setItems(order_items);
			
			OrderDAO orderDAO = getOrderDAO(req);
	
			Long orderId = orderDAO.create(order);
			
			resp.sendRedirect(req.getContextPath()+"/pages/checkout.jsp?buyer="+buyer+"&address="+address+"&email="+email+"&orderId="+orderId);
			return;
			
		}

	}
	
}
