package it.unibo.tw.web.tags;

import java.io.IOException;
import java.util.logging.Logger;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.JspTagException;
import javax.servlet.jsp.tagext.BodyContent;
import javax.servlet.jsp.tagext.BodyTagSupport;
import javax.servlet.jsp.tagext.Tag;

/**
 * Another servlet
 *
 * @author you
 */
public class WorkInProgressTagClass 
extends BodyTagSupport {
	
	// -----------------------------------------------------------
	// constants 
	// -----------------------------------------------------------
	
	private static final long serialVersionUID = 1L;

	// -----------------------------------------------------------
	// members 
	// -----------------------------------------------------------

	private Logger log = Logger.getLogger(WorkInProgressTagClass.class.getCanonicalName());
	
	private String when;

	public void setWhen(String when) {
		log.info("Setting when = " + when);
		this.when = when;
	}

	// -----------------------------------------------------------
	// init & relase methods (inherited and modified from super class) just to show how to handle them
	// -----------------------------------------------------------

    protected BodyContent bodyContent;
    public void setBodyContent(BodyContent bodyContent) {
		log.info("Retrieving bodyContent = " + bodyContent);
        this.bodyContent = bodyContent;
    }
    public void release() {
        bodyContent = null;
		log.info("Releasing bodyContent");
    }

	// -----------------------------------------------------------
    // tag processing methods...
	// -----------------------------------------------------------
    
	public int doStartTag() throws JspException {
		log.info("Evaluating opening tag");
        return BodyTagSupport.EVAL_BODY_BUFFERED;	
    }
   
    // Default implementations for BodyTag methods as well
    // just in case a tag decides to implement BodyTag.
    public void doInitBody() throws JspException {
		log.info("Before evaluating body");
    	try { 
    		this.bodyContent.getEnclosingWriter().write("<p>This page is still under construction.<br/>");
    	}
    	catch (Exception e) {
    		log.warning(e.getMessage());
    		e.printStackTrace();
		}
    }

    public int doAfterBody() throws JspException {
		log.info("After evaluating body");
        try {
    		if ( when != null && ! when.equals("") ) {
           		this.bodyContent.getEnclosingWriter().write("We will see it...." + when + "!");
            } 
       		this.bodyContent.getEnclosingWriter().write("</p>");
            return Tag.EVAL_BODY_INCLUDE;
        } catch (IOException ex) {
            throw new JspTagException(ex.toString());
        }
    }

    public int doEndTag() throws JspException {
		log.info("Evaluating closing tag");
        return BodyTagSupport.EVAL_PAGE;
    }
	
}