<!-- pagina per la gestione di errori -->
<%@ page errorPage="../errors/failure.jsp"%>

<!-- accesso alla sessione -->
<%@ page session="true"%>

<!-- import di classi Java -->
<%@ page import="it.unibo.tw.web.beans.Cart"%>
<%@page import="it.unibo.tw.dao.ItemDTO"%>
<%@page import="it.unibo.tw.dao.ItemDAO"%>
<%@page import="it.unibo.tw.dao.DAOFactory"%>

<!-- librerie di terze parti -->
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %> 

<!-- librerie di tag presenti all'interno della web application -->
<%@ taglib tagdir="/WEB-INF/tags" prefix="mytags1" %>
<%@ taglib uri="http://www.unibo.it/tw/sample" prefix="mytags2" %> 

<!-- metodi richiamati nel seguito -->
<%!
ItemDAO getItemDAO(String type) {
	return DAOFactory
		.getDAOFactory(
			Integer.parseInt(
				// can't use builtin object 'application' while in a declaration! 
				// must be in a scriptlet or expression!
				//application.getInitParameter("daoFactory")
					type)
			).getItemDAO();
}

void add(Cart cart, ItemDTO item, int order) {

	boolean alreadyInCart = false;
	
	for ( ItemDTO itemInCart : cart.getItems() ) {
		if ( itemInCart.getId().equals( item.getId() ) ) {
			alreadyInCart = true;
			order += cart.get(itemInCart);
			cart.put(item, order);
			break;
		}
	}
	
	if ( ! alreadyInCart ) {
		cart.put(item,order);
	}
			
}%>

<!-- codice html restituito al client -->

<html>
	<head>
		<meta name="Author" content="pisi79">
		<title>Cart JSP</title>
		<link rel="stylesheet" href="<%=request.getContextPath()%>/styles/default.css" type="text/css"/>
	</head>

	<body>	

		<%@ include file="../fragments/header.jsp" %>
		<%@ include file="../fragments/menu.jsp" %>
	
		<div id="main" class="clear">

			<jsp:useBean id="cart" class="it.unibo.tw.web.beans.Cart" scope="session" />
			
<%
				if ( request.getParameter("empty") != null && ! request.getParameter("empty").equals("") ) {
					cart.empty();
				}

				if ( request.getParameter("add") != null && ! request.getParameter("add").equals("") ) {
					ItemDTO item = getItemDAO( application.getInitParameter("dao") ).read( Long.parseLong( request.getParameter("id") ) );
					int qty = Integer.parseInt( request.getParameter("qty") );
					int old_qty = cart.get(item);
					if ( (qty+old_qty) > item.getAvailability() ) 
						throw new Exception("There are not enough items to complete the order!");
					else 
						add(cart,item,qty);
				}
			%>			
			
			<div id="left" style="float: left; width: 48%; border-right: 1px solid grey">
			
				<p>Select an item from the catalogue:</p>
				<table class="formdata">
					<tr>
						<th style="width: 25%">Description</th>
						<th style="width: 25%">Price</th>
						<th style="width: 25%">Your order</th>
						<th style="width: 25%"></th>
					</tr>
					<%
					for( ItemDTO item : getItemDAO( application.getInitParameter("dao") ).find(null) ) {
					%>
						<form>
							<tr>
								<td><%= item.getDescription() %></td>
								<td><%= item.getPrice() %> &#8364;</td>
								<td><input type="text" name="qty" style="background-color: #c3c3d7;"/></td>
								<td>
									<input type="hidden" name="id" value="<%= item.getId() %>"/>
									<input type="submit" name="add" value="add to cart"/>
								</td>
							</tr>
						</form>
					<% 						
					}
					%>
					<tr>
						<td>&nbsp;</td>
						<td>&nbsp;</td>
						<td>&nbsp;</td>
						<td>&nbsp;</td>
					</tr>
				</table>			
			</div>
			
			<div id="right" style="float: right; width: 48%">
				<p>Cart content:</p>
				<table class="formdata">
					<tr>
						<th style="width: 33%">Description</th>
						<th style="width: 33%">Price</th>
						<th style="width: 33%">Your order</th>
					</tr>
					<c:forEach items="${cart.items}" var="anItem">
						<mytags1:cartRow cart="${cart}" item="${anItem}"/>
					</c:forEach>
					<tr>
						<td>&nbsp;</td>
						<td>&nbsp;</td>
						<td>&nbsp;</td>
					</tr>
				</table>			
				<br/>
				<p>
				Total: <span style="font-size: x-large; color: red;">${mytags2:total(cart)} &#8364;</span>
				</p>
				
<%
				if ( cart.getItems().size() > 0 ) {
%>
					<br/>
					<a href="?empty=ok">Remove all items from the cart</a>
<%
				}
%>
			</div>
		
			<div class="clear">
				<p>&nbsp;</p>
			</div>
			
		</div>
	
		<%@ include file="../fragments/footer.jsp" %>

	</body>
</html>
